 Program User_27;

 Uses Crt, Misc;

 {$I TELEGARD.INC}

 var
    Ufile           : File of UserRec;
    Lfile           : Text;
    Line1           : String[ 80  ];
    Line2           : String[ 80  ];
    Path_to_Ufile   : String[ 255 ];
    Path_to_Lfile   : String[ 255 ];
    Total_Users     : Integer;
    White, Blue, Green, Yellow : String[ 2 ];

 procedure Read_Config;

 var
    CFile : text;
    Dummy : Char;

 begin
      White  := Chr( 3 );
      Blue   := Chr( 3 );
      Green  := Chr( 3 );
      Yellow := Chr( 3 );

      {$I-}
      Assign( CFile, 'USER27.CFG'  );
      Reset ( CFile                );
      Readln( CFile, Line1         );
      Readln( CFile, Line2         );
      Readln( CFile, Path_To_Ufile );
      Readln( CFile, Path_To_Lfile );
      Readln( CFile, Dummy );
      White [ 2 ] := Chr( Ord( Dummy ) - 48 );
      Inc( White [ 0 ] );
      Readln( CFile, Dummy );
      Yellow[ 2 ] := Chr( Ord( Dummy ) - 48 );
      Inc( Yellow[ 0 ] );
      Readln( CFile, Dummy );
      Blue  [ 2 ] := Chr( Ord( Dummy ) - 48 );
      Inc( Blue  [ 0 ] );
      Readln( CFile, Dummy );
      Green [ 2 ] := Chr( Ord( Dummy ) - 48 );
      Inc( Green[ 0 ] );
      {$I+}

      If IOResult <> 0 then
      begin
           Writeln( '>>>* Error Reading USER27.CFG! *<<<' );
           Halt( 1 );
      end;

      If Path_To_Ufile[ Length( Path_to_Ufile ) ] <> '\' then
      begin
           Path_to_Ufile[ Length( Path_to_Ufile ) + 1 ] := '\';
           Inc( Path_to_Ufile[ 0 ] );
      end;

      Insert( 'USER.LST', Path_to_Ufile, Length( Path_to_Ufile ) + 1 );

      If Path_To_Lfile[ Length( Path_to_Lfile ) ] <> '\' then
      begin
           Path_to_Lfile[ Length( Path_to_Lfile ) + 1 ] := '\';
           Inc( Path_to_Lfile[ 0 ] );
      end;

      Insert( 'USER27.MSG', Path_to_Lfile, Length( Path_to_Lfile ) + 1 );
 end;


 procedure Open_Files;

 begin
      {$I-}
      Assign( Ufile, Path_to_Ufile );
      Reset ( Ufile );
      {$I+}

      If IOResult <> 0 then
      begin
           Writeln( '>>>* Error - Unable to open USER.LST! *<<<' );
           Halt( 2 );
      end;

      {$I-}
      Assign ( Lfile, Path_to_Lfile );
      Rewrite( Lfile );
      {$I+}

      If IOResult <> 0 then
      begin
           Writeln( '>>>* Error - Unable to open USER27.MSG! *<<<' );
           Halt( 2 );
      end;

 end;


 procedure Main_Loop;

 var
    User          : UserRec;
    Counter       : Integer;

 procedure Process_Ufile;

 begin
      Total_Users := 0;
      Counter     := 1;
      Read( Ufile, User );

      While Not EOF( Ufile ) do
      begin
           Read( Ufile, User );

           If Not ( Udeleted in User.Flags ) then
           begin
                Inc( Total_Users );
                GotoXY( 11, 9 );
                Write( Counter );
                Write  ( Lfile, White, '', Yellow, Counter : 5, White, '' );
                Write  ( Lfile, Green, User.Name, ' ' : 35 - Length( User.Name ), White, '' );
                WriteLn( Lfile, Blue,  User.CityState, ' ' : 35 - Length( User.CityState ), White, '' );
           end;

           Inc( Counter );
      end;

 end;


 begin
      Writeln( '  Processing Users...' );
      Writeln( '  User #:' );

      Process_Ufile;
 end;


 procedure Print_Headers;

 begin
      ClrScr;
      Writeln( '                                     User-27 v1.00' );
      Writeln( '                                 Author: David Chase' );
      Writeln( '                               SecOfr of: Alpha Regulus' );
      Writeln( '                                    (416)274-2268' );
      Writeln( '                               Program Dated: [20.01.92]' );
      Writeln( '  ------------------------------------------------------------------------' );
      Writeln( '' );

      Writeln( LFile, '                                  ', White, 'User-27 v1.00' );
      Writeln( LFile, ' ' : 40 - Length( Line1 ) div 2, Blue, Line1 );
      Writeln( LFile, ' ' : 40 - Length( Line2 ) div 2, Blue, Line2 );
      Writeln( LFile, White, '', Rpt( '', 35 ), '', Rpt( '', 35 ), '' );
      Writeln( Lfile, White, ' Num  User Name/Handle', ' ' : 18, '', ' User State/Prov.', ' ' : 18, '' );
      Writeln( Lfile, White, '', Rpt( '', 35 ), '', Rpt( '', 35 ), '' );
 end;


 procedure Close_Files;

 begin
      {$I-}
      Close( Ufile );
      {$I+}

      If IOResult <> 0 then
      begin
           Writeln( '>>>* Error - Could not close USER.LST! *<<<' );
           Halt( 3 );
      end;

      {$I-}
      Close( Lfile );
      {$I+}

      If IOResult <> 0 then
      begin
           Writeln( '>>>* Error - Could not close USER27.MSG! *<<<' );
           Halt( 4 );
      end;

 end;


 procedure Print_Footers;

 begin
      Writeln( '' );
      Writeln( '' );
      Writeln( '  Total Active Users: ', Total_Users );

      Writeln( LFile, White, '', Rpt( '', 35 ), '', Rpt( '', 35 ), '' );
      Writeln( LFile, '' );
      Writeln( LFile, Blue, '  Total Active Users: ', Total_Users );
 end;


 begin
      Read_Config;
      Open_Files;
      Print_Headers;
      Main_Loop;
      Print_Footers;
      Close_Files;
 end.